"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useState2 = _interopRequireDefault(require("./useState.js"));

var _useVirtualScroller = _interopRequireDefault(require("./useVirtualScroller.js"));

var _useVirtualScrollerStartStop = _interopRequireDefault(require("./useVirtualScrollerStartStop.js"));

var _useInstanceMethods = _interopRequireDefault(require("./useInstanceMethods.js"));

var _useItemKeys2 = _interopRequireDefault(require("./useItemKeys.js"));

var _useSetItemState = _interopRequireDefault(require("./useSetItemState.js"));

var _useOnItemHeightDidChange = _interopRequireDefault(require("./useOnItemHeightDidChange.js"));

var _useSetNewItemsOnItemsPropertyChange = _interopRequireDefault(require("./useSetNewItemsOnItemsPropertyChange.js"));

var _useUpdateItemKeysOnItemsChange = _interopRequireDefault(require("./useUpdateItemKeysOnItemsChange.js"));

var _useClassName = _interopRequireDefault(require("./useClassName.js"));

var _useStyle = _interopRequireDefault(require("./useStyle.js"));

var _excluded = ["as", "items", "itemComponent", "itemComponentProps", "estimatedItemHeight", "getEstimatedItemHeight", "getEstimatedVisibleItemRowsCount", "bypass", "tbody", "preserveScrollPosition", "preserveScrollPositionOnPrependItems", "measureItemsBatchSize", "scrollableContainer", "getScrollableContainer", "getColumnsCount", "getItemId", "className", "onMount", "onItemFirstRender", "onItemInitialRender", "initialScrollPosition", "onScrollPositionChange", "onStateChange", "initialState", "getInitialItemState"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// When `items` property changes:
// * A new `items` property is supplied to the React component.
// * The React component re-renders itself.
// * `useSetNewItemsOnItemsPropertyChange()` hook is run.
// * `useSetNewItemsOnItemsPropertyChange()` hook detects that the `items` property
//   has changed and calls `VirtualScroller.setItems(items)`.
// * `VirtualScroller.setItems(items)` calls `VirtualScroller.setState()`.
// * `VirtualScroller.setState()` calls the `setState()` function.
// * The `setState()` function calls a setter from a `useState()` hook.
// * The React component re-renders itself the second time.
function VirtualScroller(_ref, ref) {
  var AsComponent = _ref.as,
      itemsProperty = _ref.items,
      Component = _ref.itemComponent,
      itemComponentProps = _ref.itemComponentProps,
      estimatedItemHeight = _ref.estimatedItemHeight,
      getEstimatedItemHeight = _ref.getEstimatedItemHeight,
      getEstimatedVisibleItemRowsCount = _ref.getEstimatedVisibleItemRowsCount,
      bypass = _ref.bypass,
      tbody = _ref.tbody,
      preserveScrollPosition = _ref.preserveScrollPosition,
      preserveScrollPositionOnPrependItems = _ref.preserveScrollPositionOnPrependItems,
      measureItemsBatchSize = _ref.measureItemsBatchSize,
      scrollableContainer = _ref.scrollableContainer,
      getScrollableContainer = _ref.getScrollableContainer,
      getColumnsCount = _ref.getColumnsCount,
      getItemId = _ref.getItemId,
      className = _ref.className,
      onMount = _ref.onMount,
      onItemFirstRender = _ref.onItemFirstRender,
      onItemInitialRender = _ref.onItemInitialRender,
      initialScrollPosition = _ref.initialScrollPosition,
      onScrollPositionChange = _ref.onScrollPositionChange,
      onStateChange = _ref.onStateChange,
      initialState = _ref.initialState,
      getInitialItemState = _ref.getInitialItemState,
      rest = _objectWithoutProperties(_ref, _excluded);

  // List items "container" DOM Element reference.
  var container = (0, _react.useRef)(); // Create a `VirtualScroller` instance.

  var virtualScroller = (0, _useVirtualScroller["default"])({
    items: itemsProperty,
    // `estimatedItemHeight` property name is deprecated,
    // use `getEstimatedItemHeight` property instead.
    estimatedItemHeight: estimatedItemHeight,
    getEstimatedItemHeight: getEstimatedItemHeight,
    getEstimatedVisibleItemRowsCount: getEstimatedVisibleItemRowsCount,
    bypass: bypass,
    // bypassBatchSize,
    tbody: tbody,
    onItemInitialRender: onItemInitialRender,
    // `onItemFirstRender(i)` is deprecated, use `onItemInitialRender(item)` instead.
    onItemFirstRender: onItemFirstRender,
    initialScrollPosition: initialScrollPosition,
    onScrollPositionChange: onScrollPositionChange,
    measureItemsBatchSize: measureItemsBatchSize,
    // `scrollableContainer` property is deprecated.
    // Use `getScrollableContainer()` property instead.
    scrollableContainer: scrollableContainer,
    getScrollableContainer: getScrollableContainer,
    getColumnsCount: getColumnsCount,
    getItemId: getItemId,
    AsComponent: AsComponent,
    initialState: initialState,
    getInitialItemState: getInitialItemState,
    onStateChange: onStateChange
  }, {
    container: container
  }); // Only compute the initial state once.

  var _initialState = (0, _react.useMemo)(function () {
    return virtualScroller.getInitialState();
  }, []); // Use React's `useState()` hook for managing `VirtualScroller`'s state lifecycle.
  // This way, React will re-render the component on every state update.


  var _useState = (0, _useState2["default"])({
    initialState: _initialState,
    onRender: virtualScroller.onRender,
    itemsProperty: itemsProperty
  }),
      getState = _useState.getState,
      setState = _useState.setState,
      stateToRender = _useState.stateToRender; // Use custom (external) state storage in the `VirtualScroller`.


  (0, _react.useMemo)(function () {
    virtualScroller.useState({
      getState: getState,
      setState: setState
    });
  }, []); // Start `VirtualScroller` on mount.
  // Stop `VirtualScroller` on unmount.

  (0, _useVirtualScrollerStartStop["default"])(virtualScroller); // List items are rendered with `key`s so that React doesn't
  // "reuse" `itemComponent`s in cases when `items` are changed.

  var _useItemKeys = (0, _useItemKeys2["default"])({
    getItemId: getItemId
  }),
      getItemKey = _useItemKeys.getItemKey,
      usesAutogeneratedItemKeys = _useItemKeys.usesAutogeneratedItemKeys,
      updateItemKeysForNewItems = _useItemKeys.updateItemKeysForNewItems; // Cache per-item `setItemState` functions' "references"
  // so that item components don't get re-rendered needlessly.


  var getSetItemState = (0, _useSetItemState["default"])({
    initialItemsCount: itemsProperty.length,
    virtualScroller: virtualScroller
  }); // Cache per-item `onItemHeightDidChange` functions' "references"
  // so that item components don't get re-rendered needlessly.

  var getOnItemHeightDidChange = (0, _useOnItemHeightDidChange["default"])({
    initialItemsCount: itemsProperty.length,
    virtualScroller: virtualScroller
  }); // Calls `.setItems()` if `items` property has changed.

  (0, _useSetNewItemsOnItemsPropertyChange["default"])(itemsProperty, {
    virtualScroller: virtualScroller,
    // `preserveScrollPosition` property name is deprecated,
    // use `preserveScrollPositionOnPrependItems` property instead.
    preserveScrollPosition: preserveScrollPosition,
    preserveScrollPositionOnPrependItems: preserveScrollPositionOnPrependItems
  }); // Updates `key`s if item indexes have changed.

  (0, _useUpdateItemKeysOnItemsChange["default"])(stateToRender.items, {
    virtualScroller: virtualScroller,
    usesAutogeneratedItemKeys: usesAutogeneratedItemKeys,
    updateItemKeysForNewItems: updateItemKeysForNewItems
  }); // Add instance methods to the React component.

  (0, _useInstanceMethods["default"])(ref, {
    virtualScroller: virtualScroller
  });
  (0, _react.useLayoutEffect)(function () {
    // (deprecated)
    // `onMount()` option is deprecated due to no longer being used.
    // If someone thinks there's a valid use case for it, create an issue.
    if (onMount) {
      onMount();
    }
  }, []); // `willRender()` function is no longer used.
  //
  // // `getSnapshotBeforeUpdate()` is called right before `componentDidUpdate()`.
  // // A hook equivalent/workaround for `getSnapshotBeforeUpdate()`:
  // // https://github.com/facebook/react/issues/15221#issuecomment-583448887
  // //
  // getSnapshotBeforeUpdate(prevProps, prevState) {
  // 	if (this.state !== prevState) {
  // 		this.willRender(this.state, prevState)
  // 	}
  // 	// Returns `null` to avoid React warning:
  // 	// "A snapshot value (or null) must be returned. You have returned undefined".
  // 	return null
  // }

  className = (0, _useClassName["default"])(className, {
    tbody: tbody
  });
  var style = (0, _useStyle["default"])({
    tbody: tbody,
    state: stateToRender
  });
  var currentItems = stateToRender.items,
      itemStates = stateToRender.itemStates,
      firstShownItemIndex = stateToRender.firstShownItemIndex,
      lastShownItemIndex = stateToRender.lastShownItemIndex;
  return /*#__PURE__*/_react["default"].createElement(AsComponent, _extends({}, rest, {
    ref: container,
    className: className,
    style: style
  }), currentItems.map(function (item, i) {
    if (i >= firstShownItemIndex && i <= lastShownItemIndex) {
      // * Passing `item` as `children` property is legacy and is deprecated.
      //   If version `2.x` is published in some hypothetical future,
      //   the `item` and `itemIndex` properties should be moved below
      //   `{...itemComponentProps}`.
      //
      // * Passing `itemIndex` property is legacy and is deprecated.
      //   The rationale is that setting new `items` on a React component
      //   is an asynchronous operation, so when a user obtains `itemIndex`,
      //   they don't know which `items` list does that index correspond to,
      //   therefore making it useless, or even buggy if used incorreclty.
      //
      // * Passing `onStateChange` property for legacy reasons.
      //   The new property name is `setState`.
      //   The old property name `onStateChange` is deprecated.
      //
      return /*#__PURE__*/_react["default"].createElement(Component, _extends({
        item: item,
        itemIndex: i
      }, itemComponentProps, {
        key: getItemKey(item, i),
        state: itemStates && itemStates[i],
        setState: getSetItemState(i),
        onStateChange: getSetItemState(i),
        onHeightChange: getOnItemHeightDidChange(i),
        onHeightDidChange: getOnItemHeightDidChange(i)
      }), item);
    }

    return null;
  }));
}

VirtualScroller = /*#__PURE__*/_react["default"].forwardRef(VirtualScroller);
var _default = VirtualScroller; // `PropTypes.elementType` is available in some version of `prop-types`.
// https://github.com/facebook/prop-types/issues/200

exports["default"] = _default;

var elementType = _propTypes["default"].elementType || _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].func, _propTypes["default"].object]);

VirtualScroller.propTypes = {
  as: elementType,
  items: _propTypes["default"].arrayOf(_propTypes["default"].any).isRequired,
  itemComponent: elementType.isRequired,
  itemComponentProps: _propTypes["default"].object,
  // `estimatedItemHeight` property name is deprecated,
  // use `getEstimatedItemHeight` property instead.
  estimatedItemHeight: _propTypes["default"].number,
  getEstimatedItemHeight: _propTypes["default"].func,
  getEstimatedVisibleItemRowsCount: _propTypes["default"].func,
  bypass: _propTypes["default"].bool,
  // bypassBatchSize: PropTypes.number,
  tbody: _propTypes["default"].bool,
  preserveScrollPositionOnPrependItems: _propTypes["default"].bool,
  // `preserveScrollPosition` property name is deprecated,
  // use `preserveScrollPositionOnPrependItems` instead.
  preserveScrollPosition: _propTypes["default"].bool,
  measureItemsBatchSize: _propTypes["default"].number,
  // `scrollableContainer` property is deprecated.
  // Use `getScrollableContainer()` property instead.
  scrollableContainer: _propTypes["default"].any,
  getScrollableContainer: _propTypes["default"].func,
  getColumnsCount: _propTypes["default"].func,
  getItemId: _propTypes["default"].func,
  className: _propTypes["default"].string,
  onMount: _propTypes["default"].func,
  onItemInitialRender: _propTypes["default"].func,
  // `onItemFirstRender(i)` is deprecated, use `onItemInitialRender(item)` instead.
  onItemFirstRender: _propTypes["default"].func,
  initialScrollPosition: _propTypes["default"].number,
  onScrollPositionChange: _propTypes["default"].func,
  onStateChange: _propTypes["default"].func,
  initialState: _propTypes["default"].shape({
    items: _propTypes["default"].arrayOf(_propTypes["default"].object).isRequired,
    itemStates: _propTypes["default"].arrayOf(_propTypes["default"].any).isRequired,
    firstShownItemIndex: _propTypes["default"].number.isRequired,
    lastShownItemIndex: _propTypes["default"].number.isRequired,
    beforeItemsHeight: _propTypes["default"].number.isRequired,
    afterItemsHeight: _propTypes["default"].number.isRequired,
    itemHeights: _propTypes["default"].arrayOf(_propTypes["default"].number).isRequired,
    columnsCount: _propTypes["default"].number,
    verticalSpacing: _propTypes["default"].number
  }),
  getInitialItemState: _propTypes["default"].func
};
VirtualScroller.defaultProps = {
  as: 'div'
};
//# sourceMappingURL=VirtualScroller.js.map