"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useInstanceMethods;

var _react = require("react");

var _debug = require("../utility/debug.js");

// Adds instance methods to the React component.
function useInstanceMethods(ref, _ref) {
  var virtualScroller = _ref.virtualScroller;
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      // This is a proxy for `VirtualScroller`'s `.updateLayout` instance method.
      updateLayout: function updateLayout() {
        return virtualScroller.updateLayout();
      },
      // (deprecated)
      // `.layout()` method name is deprecated, use `.updateLayout()` instead.
      layout: function layout() {
        return virtualScroller.updateLayout();
      },
      // (deprecated)
      updateItem: function updateItem(i) {
        return (0, _debug.reportError)("[virtual-scroller] \".updateItem(i)\" method of React <VirtualScroller/> has been removed");
      },
      // (deprecated)
      renderItem: function renderItem(i) {
        return (0, _debug.reportError)("[virtual-scroller] \".renderItem(i)\" method of React <VirtualScroller/> has been removed");
      }
    };
  }, [virtualScroller]);
}
//# sourceMappingURL=useInstanceMethods.js.map