"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useOnChange;

var _react = require("react");

function useOnChange(value, onChange) {
  var previousValueRef = (0, _react.useRef)(value);
  var previousValue = previousValueRef.current;
  previousValueRef.current = value;

  if (value !== previousValue) {
    onChange(value, previousValue);
  }
}
//# sourceMappingURL=useOnChange.js.map