"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

var ScrollableContainer = /*#__PURE__*/function () {
  /**
   * Constructs a new "scrollable container" from an element.
   * @param {func} getElement — Returns the scrollable container element.
   * @param {func} getItemsContainerElement — Returns items "container" element.
   */
  function ScrollableContainer(getElement, getItemsContainerElement) {
    _classCallCheck(this, ScrollableContainer);

    this.getElement = getElement;
    this.getItemsContainerElement = getItemsContainerElement;
    this.scrollTop = 0;
  }
  /**
   * Returns the current scroll position.
   * @return {number}
   */


  _createClass(ScrollableContainer, [{
    key: "getScrollY",
    value: function getScrollY() {
      return this.scrollTop;
    }
    /**
     * Scrolls to a specific position.
     * @param {number} scrollY
     */

  }, {
    key: "scrollToY",
    value: function scrollToY(scrollY) {
      this.scrollTop = scrollY;

      if (this.onScrollListener) {
        this.onScrollListener();
      }
    }
    /**
     * Returns "scrollable container" width,
     * i.e. the available width for its content.
     * @return {number}
     */

  }, {
    key: "getWidth",
    value: function getWidth() {
      return this.getElement().width;
    }
    /**
     * Returns the height of the "scrollable container" itself.
     * Not to be confused with the height of "scrollable container"'s content.
     * @return {number}
     */

  }, {
    key: "getHeight",
    value: function getHeight() {
      return this.getElement().height;
    }
    /**
     * Returns a "top offset" of an items container element
     * relative to the "scrollable container"'s top edge.
     * @return {number}
     */

  }, {
    key: "getItemsContainerTopOffset",
    value: function getItemsContainerTopOffset() {
      return 0;
    }
    /**
     * Adds a "scroll" event listener to the "scrollable container".
     * @param {onScroll} Should be called whenever the scroll position inside the "scrollable container" (potentially) changes.
     * @return {function} Returns a function that stops listening.
     */

  }, {
    key: "onScroll",
    value: function onScroll(_onScroll) {
      var _this = this;

      this.onScrollListener = _onScroll;
      return function () {
        delete _this.onScrollListener;
      };
    }
    /**
     * Adds a "resize" event listener to the "scrollable container".
     * @param {onResize} Should be called whenever the "scrollable container"'s width or height (potentially) changes.
     * @return {function} Returns a function that stops listening.
     */

  }, {
    key: "onResize",
    value: function onResize(_onResize) {
      var _this2 = this;

      this.onResizeListener = _onResize;
      return function () {
        delete _this2.onResizeListener;
      };
    } // Returns a `Promise` because `this.onResizeListener()` is a "debounced" function.
    // See `./utility/debounce.js` for more details.

  }, {
    key: "_triggerResizeListener",
    value: function _triggerResizeListener() {
      return this.onResizeListener();
    }
  }]);

  return ScrollableContainer;
}();

exports["default"] = ScrollableContainer;
//# sourceMappingURL=ScrollableContainer.js.map