export default function getVerticalSpacing(_ref) {
  var itemsContainer = _ref.itemsContainer,
      renderedItemsCount = _ref.renderedItemsCount;

  if (renderedItemsCount > 1) {
    var firstShownRowTopOffset = itemsContainer.getNthRenderedItemTopOffset(0);
    var firstShownRowHeight = itemsContainer.getNthRenderedItemHeight(0);
    var i = 1;

    while (i < renderedItemsCount) {
      var itemTopOffset = itemsContainer.getNthRenderedItemTopOffset(i);
      var itemHeight = itemsContainer.getNthRenderedItemHeight(i); // If next row is detected.

      if (itemTopOffset !== firstShownRowTopOffset) {
        // Measure inter-row spacing.
        return itemTopOffset - (firstShownRowTopOffset + firstShownRowHeight);
      } // A row height is the maximum of its item heights.


      firstShownRowHeight = Math.max(firstShownRowHeight, itemHeight);
      i++;
    }
  }
}
//# sourceMappingURL=getVerticalSpacing.js.map