function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { useMemo } from 'react';
import VirtualScroller from '../VirtualScroller.js'; // Creates a `VirtualScroller` instance.

export default function useVirtualScroller(_ref, _ref2) {
  var items = _ref.items,
      estimatedItemHeight = _ref.estimatedItemHeight,
      getEstimatedItemHeight = _ref.getEstimatedItemHeight,
      getEstimatedVisibleItemRowsCount = _ref.getEstimatedVisibleItemRowsCount,
      bypass = _ref.bypass,
      tbody = _ref.tbody,
      onItemInitialRender = _ref.onItemInitialRender,
      onItemFirstRender = _ref.onItemFirstRender,
      initialScrollPosition = _ref.initialScrollPosition,
      onScrollPositionChange = _ref.onScrollPositionChange,
      measureItemsBatchSize = _ref.measureItemsBatchSize,
      scrollableContainer = _ref.scrollableContainer,
      getScrollableContainer = _ref.getScrollableContainer,
      getColumnsCount = _ref.getColumnsCount,
      getItemId = _ref.getItemId,
      AsComponent = _ref.AsComponent,
      initialState = _ref.initialState,
      getInitialItemState = _ref.getInitialItemState,
      onStateChange = _ref.onStateChange;
  var container = _ref2.container;
  return useMemo(function () {
    var _VirtualScroller;

    // Create `virtual-scroller` instance.
    return new VirtualScroller(function () {
      return container.current;
    }, items, (_VirtualScroller = {
      _useTimeoutInRenderLoop: true,
      // `estimatedItemHeight` is deprecated, use `getEstimatedItemHeight()` instead.
      estimatedItemHeight: estimatedItemHeight,
      getEstimatedItemHeight: getEstimatedItemHeight,
      getEstimatedVisibleItemRowsCount: getEstimatedVisibleItemRowsCount,
      bypass: bypass,
      // bypassBatchSize,
      tbody: tbody,
      onItemInitialRender: onItemInitialRender,
      // `onItemFirstRender(i)` is deprecated, use `onItemInitialRender(item)` instead.
      onItemFirstRender: onItemFirstRender,
      initialScrollPosition: initialScrollPosition,
      onScrollPositionChange: onScrollPositionChange,
      measureItemsBatchSize: measureItemsBatchSize,
      // `scrollableContainer` property is deprecated.
      // Use `getScrollableContainer()` property instead.
      scrollableContainer: scrollableContainer,
      getScrollableContainer: getScrollableContainer,
      getColumnsCount: getColumnsCount,
      getItemId: getItemId
    }, _defineProperty(_VirtualScroller, "tbody", AsComponent === 'tbody'), _defineProperty(_VirtualScroller, "state", initialState), _defineProperty(_VirtualScroller, "getInitialItemState", getInitialItemState), _defineProperty(_VirtualScroller, "onStateChange", onStateChange), _VirtualScroller));
  }, []);
}
//# sourceMappingURL=useVirtualScroller.js.map